import { IConnectionBuilder } from '../builder/IConnectionBuilder';
import { IConnection } from "../connection/IConnection";
import { IArduinoCloudClient, CloudOptions, OnMessageCallback, CloudMessageValue } from "./IArduinoCloudClient";
export declare class ArduinoCloudClient implements IArduinoCloudClient {
    private builders;
    private connection;
    private subscriptions;
    private callbacks;
    private options;
    static From(connection: IConnection): ArduinoCloudClient;
    constructor(builders?: IConnectionBuilder[]);
    connect(options: CloudOptions): Promise<IConnection>;
    private init;
    disconnect(): Promise<void>;
    reconnect(): Promise<void>;
    updateToken(newToken: string): Promise<void>;
    subscribe<T extends CloudMessageValue>(topic: string, cb: OnMessageCallback<T>): Promise<void>;
    unsubscribe(topic: string): Promise<void>;
    sendMessage(topic: string, message: string | ArrayBuffer): Promise<void>;
    openCloudMonitor<T extends CloudMessageValue>(deviceId: string, cb: OnMessageCallback<T>): Promise<void>;
    writeCloudMonitor(deviceId: string, message: string | ArrayBuffer): Promise<void>;
    closeCloudMonitor(deviceId: string): Promise<void>;
    sendProperty<T extends CloudMessageValue>(thingId: string, name: string, value: T, timestamp?: number): Promise<void>;
    onPropertyValue<T extends CloudMessageValue>(thingId: string, name: string, cb: OnMessageCallback<T>): Promise<void>;
    private messagesFrom;
}
